commit 081a4f9736f3bc345872be8f61632cbed4a8d9b3
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Fri Feb 3 14:46:22 2006 +0000

    Kosmetik: Perltidy-Lauf nach den Einstellungen in doc/programmierrichtlinien.txt ueber alle .pl und .pm.

diff --git a/SL/AR.pm b/SL/AR.pm
index 76cea5579..42f8c1cc7 100644
--- a/SL/AR.pm
+++ b/SL/AR.pm
@@ -83,9 +83,10 @@ sub post_transaction {
 
   $form->{amount} = $form->{netamount};
 
-  $form->{tax} = 0;
+  $form->{tax}       = 0;
   $form->{netamount} = 0;
   $form->{total_tax} = 0;
+
   # taxincluded doesn't make sense if there is no amount
 
   $form->{taxincluded} = 0 if ($form->{amount} == 0);
@@ -114,7 +115,8 @@ sub post_transaction {
         $form->{netamount} += $form->{"amount_$i"};
       } else {
         $form->{"tax_$i"} = $form->{"amount_$i"} * $form->{"taxrate_$i"};
-        $form->{"tax_$i"} = $form->round_amount($form->{"tax_$i"} * $form->{exchangerate}, 2);
+        $form->{"tax_$i"} =
+          $form->round_amount($form->{"tax_$i"} * $form->{exchangerate}, 2);
         $form->{netamount} += $form->{"amount_$i"};
       }
     }
diff --git a/SL/DATEV.pm b/SL/DATEV.pm
index 36fe80dba..9c617dbb8 100644
--- a/SL/DATEV.pm
+++ b/SL/DATEV.pm
@@ -588,7 +588,7 @@ sub kne_buchungsexport {
   my $evfile      = "EV01";
   my @ed_versionsets;
   my $fileno = 0;
-  
+
   $form->header;
   print qq|
   <html>
@@ -616,8 +616,8 @@ sub kne_buchungsexport {
     $remaining_bytes -= length($header);
 
     while (scalar(@{ $form->{DATEV} }) > 0) {
-      $transaction    = shift @{ $form->{DATEV} };
-      $trans_lines    = scalar(@{$transaction});
+      $transaction = shift @{ $form->{DATEV} };
+      $trans_lines = scalar(@{$transaction});
       $counter++;
       if (($counter % 500) == 0) {
         print("$counter ");
@@ -829,7 +829,7 @@ sub kne_buchungsexport {
     print(EV $ed_versionset[$file]);
   }
   close(EV);
-print qq|<br>Done. <br></body>
+  print qq|<br>Done. <br></body>
 </html>
 |;
   ###
@@ -865,8 +865,7 @@ sub kne_stammdatenexport {
     qq|SELECT c.accno, c.description FROM chart c WHERE c.accno >=|
     . $dbh->quote($form->{accnofrom}) . qq|
            AND c.accno <= |
-    . $dbh->quote($form->{accnoto})
-    . qq| ORDER BY c.accno|;
+    . $dbh->quote($form->{accnoto}) . qq| ORDER BY c.accno|;
 
   $sth = $dbh->prepare($query);
   $sth->execute || $form->dberror($query);
diff --git a/SL/Form.pm b/SL/Form.pm
index 68e66836e..8670d604c 100644
--- a/SL/Form.pm
+++ b/SL/Form.pm
@@ -195,7 +195,7 @@ sub unescape {
 sub quote {
   my ($self, $str) = @_;
 
-  if ($str && ! ref($str)) {
+  if ($str && !ref($str)) {
     $str =~ s/"/&quot;/g;
   }
 
@@ -203,11 +203,10 @@ sub quote {
 
 }
 
-
 sub unquote {
   my ($self, $str) = @_;
 
-  if ($str && ! ref($str)) {
+  if ($str && !ref($str)) {
     $str =~ s/&quot;/"/g;
   }
 
@@ -215,17 +214,24 @@ sub unquote {
 
 }
 
- 
 sub hide_form {
   my $self = shift;
 
   if (@_) {
-    for (@_) { print qq|<input type=hidden name="$_" value="|.$self->quote($self->{$_}).qq|">\n| }
+    for (@_) {
+      print qq|<input type=hidden name="$_" value="|
+        . $self->quote($self->{$_})
+        . qq|">\n|;
+    }
   } else {
     delete $self->{header};
-    for (sort keys %$self) { print qq|<input type=hidden name="$_" value="|.$self->quote($self->{$_}).qq|">\n| }
+    for (sort keys %$self) {
+      print qq|<input type=hidden name="$_" value="|
+        . $self->quote($self->{$_})
+        . qq|">\n|;
+    }
   }
-  
+
 }
 
 sub error {
@@ -452,17 +458,17 @@ sub write_trigger {
     push @triggers, qq|
        Calendar.setup(
       {
-      inputField : "|.(shift).qq|",
+      inputField : "| . (shift) . qq|",
       ifFormat :"$ifFormat",
-      align : "|.(shift).qq|", 
-      button : "|.(shift).qq|"
+      align : "| .  (shift) . qq|", 
+      button : "| . (shift) . qq|"
       }
       );
        |;
   }
   $jsscript = qq|
        <script type="text/javascript">
-       <!--|.join("", @triggers).qq|//-->
+       <!--| . join("", @triggers) . qq|//-->
         </script>
         |;
 
@@ -505,12 +511,12 @@ sub format_amount {
   $main::lxdebug->enter_sub();
 
   my ($self, $myconfig, $amount, $places, $dash) = @_;
-  
+
   #Workaround for $format_amount calls without $places
-  if (!defined $places){
-  (my $dec) = ($amount =~ /\.(\d+)/);
-  $places           = length $dec;
-  }                    
+  if (!defined $places) {
+    (my $dec) = ($amount =~ /\.(\d+)/);
+    $places = length $dec;
+  }
 
   if ($places =~ /\d/) {
     $amount = $self->round_amount($amount, $places);
@@ -518,7 +524,7 @@ sub format_amount {
 
   # is the amount negative
   my $negative = ($amount < 0);
-  my $fillup = "";
+  my $fillup   = "";
 
   if ($amount != 0) {
     if ($myconfig->{numberformat} && ($myconfig->{numberformat} ne '1000.00'))
@@ -532,19 +538,19 @@ sub format_amount {
         $amount =~ s/\d{3,}?/$&,/g;
         $amount =~ s/,$//;
         $amount = join '', reverse split //, $amount;
-        $amount .= "\.$dec".$fillup if ($places ne '' && $places*1 != 0);
+        $amount .= "\.$dec" . $fillup if ($places ne '' && $places * 1 != 0);
       }
 
       if ($myconfig->{numberformat} eq '1.000,00') {
         $amount =~ s/\d{3,}?/$&./g;
         $amount =~ s/\.$//;
         $amount = join '', reverse split //, $amount;
-        $amount .= ",$dec".$fillup if ($places ne '' && $places*1 != 0);
+        $amount .= ",$dec" . $fillup if ($places ne '' && $places * 1 != 0);
       }
 
       if ($myconfig->{numberformat} eq '1000,00') {
         $amount = "$whole";
-        $amount .= ",$dec" .$fillup if ($places ne '' && $places*1 != 0);
+        $amount .= ",$dec" . $fillup if ($places ne '' && $places * 1 != 0);
       }
 
       if ($dash =~ /-/) {
@@ -576,29 +582,39 @@ sub parse_amount {
   $main::lxdebug->enter_sub();
 
   my ($self, $myconfig, $amount) = @_;
-  $main::lxdebug->message(LXDebug::DEBUG2, "Start amount: $amount");  
- 
-  if ($myconfig->{in_numberformat} == 1){
+  $main::lxdebug->message(LXDebug::DEBUG2, "Start amount: $amount");
+
+  if ($myconfig->{in_numberformat} == 1) {
+
     # Extra input number format 1000.00 or 1000,00
-    $main::lxdebug->message(LXDebug::DEBUG2, "in_numberformat: " . $main::locale->text('1000,00 or 1000.00'));
+    $main::lxdebug->message(LXDebug::DEBUG2,
+              "in_numberformat: " . $main::locale->text('1000,00 or 1000.00'));
     $amount =~ s/,/\./g;
+
     #$main::lxdebug->message(LXDebug::DEBUG2, "1.Parsed Number: $amount") if ($amount);
     $amount = scalar reverse $amount;
+
     #$main::lxdebug->message(LXDebug::DEBUG2, "2.Parsed Number: $amount") if ($amount);
     $amount =~ s/\./DOT/;
+
     #$main::lxdebug->message(LXDebug::DEBUG2, "3.Parsed Number: $amount") if ($amount);
     $amount =~ s/\.//g;
+
     #$main::lxdebug->message(LXDebug::DEBUG2, "4.Parsed Number: $amount") if ($amount);
     $amount =~ s/DOT/\./;
+
     #$main::lxdebug->message(LXDebug::DEBUG2, "5.Parsed Number:" . $amount) if ($amount);
-    $amount = scalar reverse $amount ;
-    $main::lxdebug->message(LXDebug::DEBUG2, "Parsed amount:" . $amount . "\n");
+    $amount = scalar reverse $amount;
+    $main::lxdebug->message(LXDebug::DEBUG2,
+                            "Parsed amount:" . $amount . "\n");
 
     return ($amount * 1);
 
   }
-  $main::lxdebug->message(LXDebug::DEBUG2, "in_numberformat: " . $main::locale->text('equal Outputformat'));
-  $main::lxdebug->message(LXDebug::DEBUG2, " = numberformat: $myconfig->{numberformat}");
+  $main::lxdebug->message(LXDebug::DEBUG2,
+              "in_numberformat: " . $main::locale->text('equal Outputformat'));
+  $main::lxdebug->message(LXDebug::DEBUG2,
+                          " = numberformat: $myconfig->{numberformat}");
   if (   ($myconfig->{numberformat} eq '1.000,00')
       || ($myconfig->{numberformat} eq '1000,00')) {
     $amount =~ s/\.//g;
@@ -606,14 +622,15 @@ sub parse_amount {
   }
 
   if ($myconfig->{numberformat} eq "1'000.00") {
-      $amount =~ s/'//g;
+    $amount =~ s/'//g;
   }
 
   $amount =~ s/,//g;
-  
-  $main::lxdebug->message(LXDebug::DEBUG2, "Parsed amount:" . $amount. "\n") if ($amount);
+
+  $main::lxdebug->message(LXDebug::DEBUG2, "Parsed amount:" . $amount . "\n")
+    if ($amount);
   $main::lxdebug->leave_sub();
-  
+
   return ($amount * 1);
 }
 
@@ -625,20 +642,18 @@ sub round_amount {
 
   # Rounding like "Kaufmannsrunden"
   # Descr. http://de.wikipedia.org/wiki/Rundung
-  # Inspired by 
+  # Inspired by
   # http://www.perl.com/doc/FAQs/FAQ/oldfaq-html/Q4.13.html
   # Solves Bug: 189
   # Udo Spallek
-  $amount       = $amount * (10 ** ($places));
-  $round_amount = int($amount + .5 * ($amount <=> 0))/(10**($places));
+  $amount = $amount * (10**($places));
+  $round_amount = int($amount + .5 * ($amount <=> 0)) / (10**($places));
 
   $main::lxdebug->leave_sub();
 
   return $round_amount;
-  
-}
-
 
+}
 
 sub parse_template {
   $main::lxdebug->enter_sub();
@@ -754,8 +769,11 @@ sub parse_template {
           }
 
           # Yes we need a manual page break -- or the user has forced one
-          if ((($current_line + $lines) > $lpp) ||
-              ($self->{"_forced_pagebreaks"} && grep(/^${current_row}$/, @{$self->{"_forced_pagebreaks"}}))) {
+          if (
+             (($current_line + $lines) > $lpp)
+             || ($self->{"_forced_pagebreaks"}
+               && grep(/^${current_row}$/, @{ $self->{"_forced_pagebreaks"} }))
+            ) {
             my $pb = $pagebreak;
 
             # replace the special variables <%sumcarriedforward%>
@@ -1042,7 +1060,7 @@ sub format_string {
   my %unique_fields;
 
   %unique_fields = map({ $_ => 1 } @fields);
-  @fields = keys(%unique_fields);
+  @fields        = keys(%unique_fields);
 
   foreach my $field (@fields) {
     next unless ($self->{$field} =~ /\<pagebreak\>/);
@@ -1295,7 +1313,7 @@ sub get_exchangerate {
   $main::lxdebug->enter_sub();
 
   my ($self, $dbh, $curr, $transdate, $fld) = @_;
-  
+
   unless ($transdate) {
     $main::lxdebug->leave_sub();
     return "";
@@ -1348,8 +1366,9 @@ sub add_shipto {
   my ($self, $dbh, $id) = @_;
 ##LINET
   my $shipto;
-  foreach
-    my $item (qw(name department_1 department_2 street zipcode city country contact phone fax email)) {
+  foreach my $item (
+    qw(name department_1 department_2 street zipcode city country contact phone fax email)
+    ) {
     if ($self->{"shipto$item"}) {
       $shipto = 1 if ($self->{$item} ne $self->{"shipto$item"});
     }
@@ -1357,7 +1376,8 @@ sub add_shipto {
   }
 
   if ($shipto) {
-    my $query = qq|INSERT INTO shipto (trans_id, shiptoname, shiptodepartment_1, shiptodepartment_2, shiptostreet,
+    my $query =
+      qq|INSERT INTO shipto (trans_id, shiptoname, shiptodepartment_1, shiptodepartment_2, shiptostreet,
                    shiptozipcode, shiptocity, shiptocountry, shiptocontact,
 		   shiptophone, shiptofax, shiptoemail) VALUES ($id,
 		   '$self->{shiptoname}', '$self->{shiptodepartment_1}', '$self->{shiptodepartment_2}', '$self->{shiptostreet}',
@@ -1616,8 +1636,7 @@ sub create_links {
   my %xkeyref = ();
 
   # now get the account numbers
-  $query =
-    qq|SELECT c.accno, c.description, c.link, c.taxkey_id
+  $query = qq|SELECT c.accno, c.description, c.link, c.taxkey_id
               FROM chart c
 	      WHERE c.link LIKE '%$module%'
 	      ORDER BY c.accno|;
@@ -1700,14 +1719,14 @@ sub create_links {
     $self->{exchangerate} =
       $self->get_exchangerate($dbh, $self->{currency}, $self->{transdate},
                               $fld);
-    my $index=0;
+    my $index = 0;
 
     # store amounts in {acc_trans}{$key} for multiple accounts
     while (my $ref = $sth->fetchrow_hashref(NAME_lc)) {
       $ref->{exchangerate} =
         $self->get_exchangerate($dbh, $self->{currency}, $ref->{transdate},
                                 $fld);
-      if ( !($xkeyref{ $ref->{accno} } =~ /tax/)) {
+      if (!($xkeyref{ $ref->{accno} } =~ /tax/)) {
         $index++;
       }
       $ref->{index} = $index;
@@ -2143,7 +2162,6 @@ sub get_partsgroup {
   $main::lxdebug->leave_sub();
 }
 
-
 sub get_pricegroup {
   $main::lxdebug->enter_sub();
 
@@ -2175,92 +2193,95 @@ sub get_pricegroup {
   $main::lxdebug->leave_sub();
 }
 
-
 sub audittrail {
   my ($self, $dbh, $myconfig, $audittrail) = @_;
-  
-# table, $reference, $formname, $action, $id, $transdate) = @_;
+
+  # table, $reference, $formname, $action, $id, $transdate) = @_;
 
   my $query;
   my $rv;
   my $disconnect;
 
-  if (! $dbh) {
-    $dbh = $self->dbconnect($myconfig);
+  if (!$dbh) {
+    $dbh        = $self->dbconnect($myconfig);
     $disconnect = 1;
   }
-    
+
   # if we have an id add audittrail, otherwise get a new timestamp
-  
+
   if ($audittrail->{id}) {
-    
+
     $query = qq|SELECT audittrail FROM defaults|;
-    
+
     if ($dbh->selectrow_array($query)) {
       my ($null, $employee_id) = $self->get_employee($dbh);
 
       if ($self->{audittrail} && !$myconfig) {
-	chop $self->{audittrail};
-	
-	my @a = split /\|/, $self->{audittrail};
-	my %newtrail = ();
-	my $key;
-	my $i;
-	my @flds = qw(tablename reference formname action transdate);
-
-	# put into hash and remove dups
-	while (@a) {
-	  $key = "$a[2]$a[3]";
-	  $i = 0;
-	  $newtrail{$key} = { map { $_ => $a[$i++] } @flds };
-	  splice @a, 0, 5;
-	}
-	
-	$query = qq|INSERT INTO audittrail (trans_id, tablename, reference,
+        chop $self->{audittrail};
+
+        my @a = split /\|/, $self->{audittrail};
+        my %newtrail = ();
+        my $key;
+        my $i;
+        my @flds = qw(tablename reference formname action transdate);
+
+        # put into hash and remove dups
+        while (@a) {
+          $key = "$a[2]$a[3]";
+          $i   = 0;
+          $newtrail{$key} = { map { $_ => $a[$i++] } @flds };
+          splice @a, 0, 5;
+        }
+
+        $query = qq|INSERT INTO audittrail (trans_id, tablename, reference,
 		    formname, action, employee_id, transdate)
 	            VALUES ($audittrail->{id}, ?, ?,
 		    ?, ?, $employee_id, ?)|;
-	my $sth = $dbh->prepare($query) || $self->dberror($query);
-
-	foreach $key (sort { $newtrail{$a}{transdate} cmp $newtrail{$b}{transdate} } keys %newtrail) {
-	  $i = 1;
-	  for (@flds) { $sth->bind_param($i++, $newtrail{$key}{$_}) }
-
-	  $sth->execute || $self->dberror;
-	  $sth->finish;
-	}
+        my $sth = $dbh->prepare($query) || $self->dberror($query);
+
+        foreach $key (
+          sort {
+            $newtrail{$a}{transdate} cmp $newtrail{$b}{transdate}
+          } keys %newtrail
+          ) {
+          $i = 1;
+          for (@flds) { $sth->bind_param($i++, $newtrail{$key}{$_}) }
+
+          $sth->execute || $self->dberror;
+          $sth->finish;
+        }
       }
 
-     
       if ($audittrail->{transdate}) {
-	$query = qq|INSERT INTO audittrail (trans_id, tablename, reference,
+        $query = qq|INSERT INTO audittrail (trans_id, tablename, reference,
 		    formname, action, employee_id, transdate) VALUES (
 		    $audittrail->{id}, '$audittrail->{tablename}', |
-		    .$dbh->quote($audittrail->{reference}).qq|,
+          . $dbh->quote($audittrail->{reference}) . qq|,
 		    '$audittrail->{formname}', '$audittrail->{action}',
 		    $employee_id, '$audittrail->{transdate}')|;
       } else {
-	$query = qq|INSERT INTO audittrail (trans_id, tablename, reference,
+        $query = qq|INSERT INTO audittrail (trans_id, tablename, reference,
 		    formname, action, employee_id) VALUES ($audittrail->{id},
 		    '$audittrail->{tablename}', |
-		    .$dbh->quote($audittrail->{reference}).qq|,
+          . $dbh->quote($audittrail->{reference}) . qq|,
 		    '$audittrail->{formname}', '$audittrail->{action}',
 		    $employee_id)|;
       }
       $dbh->do($query);
     }
   } else {
-    
+
     $query = qq|SELECT current_timestamp FROM defaults|;
     my ($timestamp) = $dbh->selectrow_array($query);
 
-    $rv = "$audittrail->{tablename}|$audittrail->{reference}|$audittrail->{formname}|$audittrail->{action}|$timestamp|";
+    $rv =
+      "$audittrail->{tablename}|$audittrail->{reference}|$audittrail->{formname}|$audittrail->{action}|$timestamp|";
   }
 
   $dbh->disconnect if $disconnect;
-  
+
   $rv;
-  
+
 }
 
 package Locale;
diff --git a/SL/GL.pm b/SL/GL.pm
index 1cc3d3447..d6723d3c5 100644
--- a/SL/GL.pm
+++ b/SL/GL.pm
@@ -283,9 +283,12 @@ sub all_transactions {
     $apwhere .= " AND c.gifi_accno = '$form->{gifi_accno}'";
   }
   if ($form->{category} ne 'X') {
-    $glwhere .= " AND gl.id in (SELECT trans_id FROM acc_trans ac2 WHERE ac2.chart_id IN (SELECT id FROM chart c2 WHERE c2.category = '$form->{category}'))";
-    $arwhere .= " AND ar.id in (SELECT trans_id FROM acc_trans ac2 WHERE ac2.chart_id IN (SELECT id FROM chart c2 WHERE c2.category = '$form->{category}'))";
-    $apwhere .= " AND ap.id in (SELECT trans_id FROM acc_trans ac2 WHERE ac2.chart_id IN (SELECT id FROM chart c2 WHERE c2.category = '$form->{category}'))";
+    $glwhere .=
+      " AND gl.id in (SELECT trans_id FROM acc_trans ac2 WHERE ac2.chart_id IN (SELECT id FROM chart c2 WHERE c2.category = '$form->{category}'))";
+    $arwhere .=
+      " AND ar.id in (SELECT trans_id FROM acc_trans ac2 WHERE ac2.chart_id IN (SELECT id FROM chart c2 WHERE c2.category = '$form->{category}'))";
+    $apwhere .=
+      " AND ap.id in (SELECT trans_id FROM acc_trans ac2 WHERE ac2.chart_id IN (SELECT id FROM chart c2 WHERE c2.category = '$form->{category}'))";
   }
 
   if ($form->{accno}) {
@@ -344,19 +347,20 @@ sub all_transactions {
 
   my $false = ($myconfig->{dbdriver} eq 'Pg') ? FALSE: q|'0'|;
 
-     my $sortorder = join ', ', $form->sort_columns(qw(transdate reference source description accno));
-     my %ordinal = ( transdate => 6,
-                     reference => 4,
-                     source => 7,
-   		  description => 5 );
-     map { $sortorder =~ s/$_/$ordinal{$_}/ } keys %ordinal;
-   
-     if ($form->{sort}) {
-         $sortorder = $form->{sort} . ",";
-     } else {
-        $sortorder = "";
-      }
-  
+  my $sortorder = join ', ',
+    $form->sort_columns(qw(transdate reference source description accno));
+  my %ordinal = (transdate   => 6,
+                 reference   => 4,
+                 source      => 7,
+                 description => 5);
+  map { $sortorder =~ s/$_/$ordinal{$_}/ } keys %ordinal;
+
+  if ($form->{sort}) {
+    $sortorder = $form->{sort} . ",";
+  } else {
+    $sortorder = "";
+  }
+
   my $query =
     qq|SELECT g.id, 'gl' AS type, $false AS invoice, g.reference, ac.taxkey, t.taxkey AS sorttax,
                  g.description, ac.transdate, ac.source, ac.trans_id,
@@ -389,7 +393,7 @@ sub all_transactions {
 	         ORDER BY $sortorder transdate, trans_id, taxkey DESC, sorttax DESC,oid|;
   my $sth = $dbh->prepare($query);
   $sth->execute || $form->dberror($query);
-  my $trans_id = "";
+  my $trans_id  = "";
   my $trans_id2 = "";
   while (my $ref0 = $sth->fetchrow_hashref(NAME_lc)) {
     $trans_id = $ref0->{id};
@@ -398,13 +402,14 @@ sub all_transactions {
         push @{ $form->{GL} }, $ref;
         $balance = 0;
       }
-      $ref = $ref0;
+      $ref       = $ref0;
       $trans_id2 = $ref->{id};
-      
+
       # gl
       if ($ref->{type} eq "gl") {
         $ref->{module} = "gl";
       }
+
       # ap
       if ($ref->{type} eq "ap") {
         if ($ref->{invoice}) {
@@ -413,7 +418,7 @@ sub all_transactions {
           $ref->{module} = "ap";
         }
       }
-  
+
       # ar
       if ($ref->{type} eq "ar") {
         if ($ref->{invoice}) {
@@ -447,55 +452,56 @@ sub all_transactions {
         }
       }
     } else {
-      $ref2 = $ref0;
+      $ref2      = $ref0;
       $trans_id2 = $ref2->{id};
-#      if ($form->{accno} eq ''){ # flo & udo: if general report,
-                                  # then check balance
-#         while (abs($balance) >= 0.015) {
-#           my $ref2 = $sth->fetchrow_hashref(NAME_lc)
-#             || $form->error("Unbalanced ledger!");
-#     
-          $balance =
-            (int($balance * 100000) + int(100000 * $ref2->{amount})) / 100000;
-          if ($ref2->{amount} < 0) {
-            if ($ref2->{chart_id} > 0) {
-              if ($ref->{debit_tax_accno}{$i} ne "") {
-                $i++;
-              }
-              $ref->{debit_tax}{$i}       = $ref2->{amount} * -1;
-              $ref->{debit_tax_accno}{$i} = $ref2->{accno};
-            } else {
-              if ($ref->{debit_accno}{$k} ne "") {
-                $k++;
-              }
-              $ref->{debit}{$k}        = $ref2->{amount} * -1;
-              $ref->{debit_accno}{$k}  = $ref2->{accno};
-              $ref->{debit_taxkey}{$k} = $ref2->{taxkey};
-            }
-          } else {
-            if ($ref2->{chart_id} > 0) {
-              if ($ref->{credit_tax_accno}{$j} ne "") {
-                $j++;
-              }
-              $ref->{credit_tax}{$j}       = $ref2->{amount};
-              $ref->{credit_tax_accno}{$j} = $ref2->{accno};
-            } else {
-              if ($ref->{credit_accno}{$l} ne "") {
-                $l++;
-              }
-              $ref->{credit}{$l}        = $ref2->{amount};
-              $ref->{credit_accno}{$l}  = $ref2->{accno};
-              $ref->{credit_taxkey}{$l} = $ref2->{taxkey};
-            }
+
+      #      if ($form->{accno} eq ''){ # flo & udo: if general report,
+      # then check balance
+      #         while (abs($balance) >= 0.015) {
+      #           my $ref2 = $sth->fetchrow_hashref(NAME_lc)
+      #             || $form->error("Unbalanced ledger!");
+      #
+      $balance =
+        (int($balance * 100000) + int(100000 * $ref2->{amount})) / 100000;
+      if ($ref2->{amount} < 0) {
+        if ($ref2->{chart_id} > 0) {
+          if ($ref->{debit_tax_accno}{$i} ne "") {
+            $i++;
           }
-#         }
-#       } else {
-#         # if account-report, then calculate the Balance?!
-#         # ToDo: Calculate the Balance
-#         1;
-#       }
+          $ref->{debit_tax}{$i}       = $ref2->{amount} * -1;
+          $ref->{debit_tax_accno}{$i} = $ref2->{accno};
+        } else {
+          if ($ref->{debit_accno}{$k} ne "") {
+            $k++;
+          }
+          $ref->{debit}{$k}        = $ref2->{amount} * -1;
+          $ref->{debit_accno}{$k}  = $ref2->{accno};
+          $ref->{debit_taxkey}{$k} = $ref2->{taxkey};
+        }
+      } else {
+        if ($ref2->{chart_id} > 0) {
+          if ($ref->{credit_tax_accno}{$j} ne "") {
+            $j++;
+          }
+          $ref->{credit_tax}{$j}       = $ref2->{amount};
+          $ref->{credit_tax_accno}{$j} = $ref2->{accno};
+        } else {
+          if ($ref->{credit_accno}{$l} ne "") {
+            $l++;
+          }
+          $ref->{credit}{$l}        = $ref2->{amount};
+          $ref->{credit_accno}{$l}  = $ref2->{accno};
+          $ref->{credit_taxkey}{$l} = $ref2->{taxkey};
+        }
+      }
+
+      #         }
+      #       } else {
+      #         # if account-report, then calculate the Balance?!
+      #         # ToDo: Calculate the Balance
+      #         1;
+      #       }
     }
-       
 
   }
   push @{ $form->{GL} }, $ref;
diff --git a/SL/IC.pm b/SL/IC.pm
index fd8a23061..eaa5e880b 100644
--- a/SL/IC.pm
+++ b/SL/IC.pm
@@ -34,6 +34,7 @@
 
 package IC;
 use Data::Dumper;
+
 sub get_part {
   $main::lxdebug->enter_sub();
 
@@ -235,8 +236,8 @@ sub get_pricegroups {
   $main::lxdebug->enter_sub();
 
   my ($self, $myconfig, $form) = @_;
-  my $dbh = $form->dbconnect($myconfig);
-  my $i = 1;
+  my $dbh                  = $form->dbconnect($myconfig);
+  my $i                    = 1;
   my @pricegroups_not_used = ();
 
   # get pricegroups
@@ -276,7 +277,6 @@ sub get_pricegroups {
   $main::lxdebug->leave_sub();
 }
 
-
 sub save {
   $main::lxdebug->enter_sub();
 
@@ -456,11 +456,14 @@ sub save {
   # insert price records only if different to sellprice
   for my $i (1 .. $form->{price_rows}) {
     if ($form->{"price_$i"} eq "0") {
-       $form->{"price_$i"} = $form->{sellprice};
+      $form->{"price_$i"} = $form->{sellprice};
     }
-    if ((   $form->{"price_$i"} 
-        || $form->{"klass_$i"}
-        || $form->{"pricegroup_id_$i"}) and $form->{"price_$i"} != $form->{sellprice}) {
+    if (
+        (   $form->{"price_$i"}
+         || $form->{"klass_$i"}
+         || $form->{"pricegroup_id_$i"})
+        and $form->{"price_$i"} != $form->{sellprice}
+      ) {
       $klass = $form->parse_amount($myconfig, $form->{"klass_$i"});
       $price = $form->parse_amount($myconfig, $form->{"price_$i"});
       $pricegroup_id =
@@ -1041,7 +1044,8 @@ sub all_parts {
         $ordwhere .= " AND lower(oi.description) LIKE '$var'";
       }
 
-      $flds = qq|p.id, p.partnumber, oi.description, oi.serialnumber AS serialnumber,
+      $flds =
+        qq|p.id, p.partnumber, oi.description, oi.serialnumber AS serialnumber,
                  oi.qty AS onhand, oi.unit, p.bin, oi.sellprice,
 	         p.listprice, p.lastcost, p.rop, p.weight,
 		 p.priceupdate, p.image, p.drawing, p.microfiche,
@@ -1067,7 +1071,8 @@ sub all_parts {
       }
 
       if ($form->{onorder}) {
-        $flds = qq|p.id, p.partnumber, oi.description, oi.serialnumber AS serialnumber,
+        $flds =
+          qq|p.id, p.partnumber, oi.description, oi.serialnumber AS serialnumber,
                    oi.qty * -1 AS onhand, oi.unit, p.bin, oi.sellprice,
 		   p.listprice, p.lastcost, p.rop, p.weight,
 		   p.priceupdate, p.image, p.drawing, p.microfiche,
@@ -1104,7 +1109,8 @@ sub all_parts {
         $quowhere .= " AND lower(oi.description) LIKE '$var'";
       }
 
-      $flds = qq|p.id, p.partnumber, oi.description, oi.serialnumber AS serialnumber,
+      $flds =
+        qq|p.id, p.partnumber, oi.description, oi.serialnumber AS serialnumber,
                  oi.qty AS onhand, oi.unit, p.bin, oi.sellprice,
 	         p.listprice, p.lastcost, p.rop, p.weight,
 		 p.priceupdate, p.image, p.drawing, p.microfiche,
@@ -1130,7 +1136,8 @@ sub all_parts {
       }
 
       if ($form->{rfq}) {
-        $flds = qq|p.id, p.partnumber, oi.description, oi.serialnumber AS serialnumber,
+        $flds =
+          qq|p.id, p.partnumber, oi.description, oi.serialnumber AS serialnumber,
                    oi.qty * -1 AS onhand, oi.unit, p.bin, oi.sellprice,
 		   p.listprice, p.lastcost, p.rop, p.weight,
 		   p.priceupdate, p.image, p.drawing, p.microfiche,
diff --git a/SL/IS.pm b/SL/IS.pm
index 04144ff70..d4d8c6f1d 100644
--- a/SL/IS.pm
+++ b/SL/IS.pm
@@ -106,10 +106,10 @@ sub invoice_details {
       push(@{ $form->{description} },   qq|$form->{"description_$i"}|);
       push(@{ $form->{qty} },
            $form->format_amount($myconfig, $form->{"qty_$i"}));
-      push(@{ $form->{unit} },         qq|$form->{"unit_$i"}|);
+      push(@{ $form->{unit} },            qq|$form->{"unit_$i"}|);
       push(@{ $form->{deliverydate_oe} }, qq|$form->{"deliverydate_$i"}|);
 
-      push(@{ $form->{sellprice} }, $form->{"sellprice_$i"});
+      push(@{ $form->{sellprice} },    $form->{"sellprice_$i"});
       push(@{ $form->{ordnumber_oe} }, qq|$form->{"ordnumber_$i"}|);
       push(@{ $form->{transdate_oe} }, qq|$form->{"transdate_$i"}|);
 
@@ -139,10 +139,14 @@ sub invoice_details {
       $dec = length $dec;
       my $decimalplaces = ($dec > 2) ? $dec : 2;
 
-      my $i_discount = $form->round_amount($sellprice * 
-                                           $form->parse_amount($myconfig, $form->{"discount_$i"}) / 100, $decimalplaces);
+      my $i_discount =
+        $form->round_amount(
+                            $sellprice * $form->parse_amount($myconfig,
+                                                 $form->{"discount_$i"}) / 100,
+                            $decimalplaces);
 
-      my $discount = $form->round_amount($form->{"qty_$i"} * $i_discount, $decimalplaces);
+      my $discount =
+        $form->round_amount($form->{"qty_$i"} * $i_discount, $decimalplaces);
 
       # keep a netprice as well, (sellprice - discount)
       $form->{"netprice_$i"} = $sellprice - $i_discount;
@@ -164,7 +168,7 @@ sub invoice_details {
         : " ";
       $linetotal = ($linetotal != 0) ? $linetotal : " ";
 
-      push(@{ $form->{discount} }, $discount);
+      push(@{ $form->{discount} },   $discount);
       push(@{ $form->{p_discount} }, $form->{"discount_$i"});
 
       $form->{total} += $linetotal;
@@ -803,9 +807,10 @@ sub post_invoice {
   # set values which could be empty to 0
   $form->{terms}       *= 1;
   $form->{taxincluded} *= 1;
-  my $datepaid     = ($form->{paid})         ? qq|'$form->{datepaid}'| : "NULL";
-  my $duedate      = ($form->{duedate})      ? qq|'$form->{duedate}'|  : "NULL";
-  my $deliverydate = ($form->{deliverydate}) ? qq|'$form->{deliverydate}'| : "NULL";
+  my $datepaid = ($form->{paid})    ? qq|'$form->{datepaid}'| : "NULL";
+  my $duedate  = ($form->{duedate}) ? qq|'$form->{duedate}'|  : "NULL";
+  my $deliverydate =
+    ($form->{deliverydate}) ? qq|'$form->{deliverydate}'| : "NULL";
 
   # fill in subject if there is none
   $form->{subject} = qq|$form->{label} $form->{invnumber}|
